Subject: [rtcweb] JSEP issue regarding TRANSPORT/IDENTICAL mux category attributes

From: Christer Holmberg <[email-masked]>
Date: Fri, 7 Apr 2017 09:09:43 +0000

Hi,

I have found an issue in JSEP.

Section 5.2.1 says:

   "Each m= section, provided it is not marked as bundle-only, MUST
   generate a unique set of ICE credentials and gather its own unique
   set of ICE candidates.  Bundle-only m= sections MUST NOT contain any
   ICE credentials and MUST NOT gather any candidates.”

…and:

   "[I-D.ietf-mmusic-sdp-mux-attributes] groups SDP attributes into
   different categories.  To avoid unnecessary duplication when
   bundling, Section 8.1 of [I-D.ietf-mmusic-sdp-bundle-negotiation]
   specifies that attributes of category IDENTICAL or TRANSPORT should
   not be repeated in bundled m= sections."

First, the two paragraphs contradict each other, because the ICE credentials (SDP ‘ice-ufrag’, ice-pwd’ etc attributes) are of TRANSPORT category.

Second, according to BUNDLE, IDENTICAL/TRANSPORT category attributes are not duplicated if the m- section 1) contains a shared address (BUNDLE address) or 2) is bundle-only.
If the m- line contains a unique address, which is common in the initial offer, attributes need to be associated with each m- line. However, the text does not address that.

I think the easiest way to fix it is by simply s/“specifies that attributes”/ “specifies WHEN attributes”.

…and change “should not” to “must not”.

Regards,

Christer

---

From: Taylor Brandstetter <[email-masked]>
Date: Fri, 7 Apr 2017 10:28:49 -0700

The suggestion to change "specifies that attributes... should not be
repeated" to "specifies when attributes ... MUST not be repeated" sounds
good to me. The actual "when" is described in more detail in the following
paragraphs.

On Fri, Apr 7, 2017 at 2:09 AM, Christer Holmberg <
[email-masked]> wrote:

> First, the two paragraphs contradict each other, because the ICE
> credentials (SDP ‘ice-ufrag’, ice-pwd’ etc attributes) are of TRANSPORT
> category.
>
> Second, according to BUNDLE, IDENTICAL/TRANSPORT category attributes are
> not duplicated if the m- section 1) contains a shared address (BUNDLE
> address) or 2) is bundle-only.
> If the m- line contains a unique address, which is common in the initial
> offer, attributes need to be associated with each m- line. However, the
> text does not address that.
>
> I think the easiest way to fix it is by simply s/“specifies that
> attributes”/ “specifies WHEN attributes”.
>
> _______________________________________________
> rtcweb mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtcweb
>
>

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 7 Apr 2017 18:05:25 +0000

Hi,

>The suggestion to change "specifies that attributes... should not be repeated" to "specifies when attributes ... MUST not be repeated" sounds
>good to me. The actual "when" is described in more detail in the following paragraphs.

I don’t think we should describe the “when” in JSEP – at least not using RFC 2119 terminology. We should reference the “Mux considerations” section in BUNDLE. I have created a BUNDLE PR that (among other things) clarifies the “when” within that section.

https://github.com/cdh4u/draft-sdp-bundle/pull/33/commits/9d3d02d04ca036e2b128d760b61c73e5dd1a0a48

JSEP also contains the following statement (and a number of similar statements):

   “The following attributes, which are of category IDENTICAL or
   TRANSPORT, MUST appear only in "m=" sections which either have a
   unique address or which are associated with the bundle-tag.”

While correct, I again think we should either reference to BUNDLE for the “when”, OR say something like “According to BUNDLE, the following attributes, which…”.

That way, if something for whatever reason changes in BUNDLE, JSEP will automatically be aligned.

Regards,

Christer

On Fri, Apr 7, 2017 at 2:09 AM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

Section 5.2.1 says:

…and:

Regards,

Christer

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

---

From: Justin Uberti <[email-masked]>
Date: Thu, 13 Apr 2017 20:57:26 -0700

I think it makes sense for JSEP to reference appropriate text in
bundle-negotiation.

However, I didn't see the specific contradiction that you indicated in your
initial email. Can you explain more?

On Fri, Apr 7, 2017 at 11:05 AM, Christer Holmberg <
[email-masked]> wrote:

> I don’t think we should describe the “when” in JSEP – at least not using
> RFC 2119 terminology. We should reference the “Mux considerations” section
> in BUNDLE. I have created a BUNDLE PR that (among other things) clarifies
> the “when” within that section.
>
>
>
> While correct, I again think we should either reference to BUNDLE for the
> “when”, OR say something like “According to BUNDLE, the following
> attributes, which…”.
>
>
>